"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = filter;
function next(chain) {
  var nextFn = chain[0];
  var newChain = Object.assign(chain.slice(1, chain.length), { next: next });

  for (var _len = arguments.length, params = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    params[_key - 1] = arguments[_key];
  }

  return nextFn.apply(undefined, [newChain].concat(params));
}

function filter(actualFn) {
  var chain = [actualFn];

  function run() {
    for (var _len2 = arguments.length, params = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      params[_key2] = arguments[_key2];
    }

    return next.apply(undefined, [chain].concat(params));
  }

  var self = Object.assign(run, {
    addFilter: function addFilter(filterFn) {
      chain.unshift(filterFn);
      return self;
    }
  });

  return self;
}